 ###############################################
#                                               #
#              DETECTEUR DE VENTS               #
#       v1.3 (26/09/2007)    by MenzAgitat      #
#                                               #
#          http://www.boulets-roxx.com          #
#        IRC:  irc.teepi.net    #boulets        #
#              irc.epiknet.org  #boulets        #
#-----------------------------------------------#
# Remerciements  Galdinx pour quelques         #
# amliorations / corrections / suggestions     #
 ###############################################

#
# Description
#
# This script detects whenever someone blows someone else off and
# makes the bot respond in a funny manner to that.
# If someone ask a question and nobody answers it, or if someone
# gives a monolog long enough, he is blown off.
# The sentence that contains the question must end by a question
# mark and a lapse of time must pass without someone else talks to
# trigger the Blow off Detector.
#
# Ce script dtecte lorsque quelqu'un se prend un "vent" et fait
# rpondre le bot d'une faon amusante.
# Si quelqu'un pose une question et que personne n'y rpond
# ou si quelqu'un entame un monologue assez long sans que personne
# n'intervienne, il s'agit d'un vent.
# La phrase contenant la question doit se terminer par un point 
# d'interrogation et un certain temps s'couler sans que personne
# ne parle pour que le dtecteur de vent s'active.
#

#
# Changelog :
#   1.0  : 1st version
#          - 1re version
#   1.1  : fixed double replies from the bot.
#          - le bot ne met plus de double vents.
#   1.2  : enhanced questions detection
#          - amlioration de la dtection des questions
#          some bug fixes
#          - correction de quelques bugs
#   1.3  : copy/paste and flood actions are excepted from monologs
#          minor bug fix
#          added TRUE multichannel support (previous one was buggy)
#          - les copier/coller et le flood sont retirs des monologues
#          - correction d'un petit bug
#          - ajout d'un VERITABLE support multi-channel (celui d'avant
#            tait foireux)
#

#
# LICENCE:
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A RTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#

namespace eval wind_detector {

  #############################
  #        PARAMETRES         #
  #############################

  ##### Chans on which the Blow off Detector will be available
  ##### example : set allowed_chans "#chan1 #chan2 chan3"
  #
  ##### Chans sur lesquels le Dtecteur de Vents sera disponible
  ##### exemple : set allowed_chans "#chan1 #chan2 chan3"
  set allowed_chans "#yourchan"
  
  ##### Time in seconds before considering someone has been blown off
  #
  ##### Temps en secondes avant de dcider qu'il s'agit d'un vent
  variable trigger_delay 120
  
  ##### How many lines of monolog will it take to consider somone has
  ##### been blown off ?
  #
  ##### A partir de combien de lignes de monologue s'agit-il d'un vent ?
  variable monolog_trigger 8

  ##### List of exempted nicks. You can add bot names for example.
  ##### Example : variable exempt_list "nick1 lamenick anothernick"
  #
  ##### Liste de nicks qui seront exempts du dtecteur de vents.
  ##### Vous pouvez y ajouter les bots par exemple.
  ##### Exemple : variable exempt_list "nick1 lamenick anothernick"
  variable exempt_list "example"

  ##### Replies to use whenever someone asks a question and gets blown off
  ##### You may add your own replies or translate these.
  ##### You may use some variables :
  #####     :ACTION: at the very beginning of a line will make the bot to talk
  #####              like a /me (ctcp action) 
  #####     :NICK: will be replaced by the nick of the user who triggered the
  #####            Blow off Detector.
  ##### Make sure you preserve the { } around the replies.
  #
  ##### Rponses du bot pour les vents dclenchs par une question.
  ##### Vous pouvez ajouter les vtres.
  ##### Il est possible d'utiliser des variables :
  #####     :ACTION: en dbut de ligne fera parler le bot en /me
  #####     :NICK: sera remplac par le nom de la personne qui a
  #####            dclench le dtecteur de vents.
  ##### Respectez bien les { } autour des rponses.
  set question_winds {
    {C'est donc a un vent :)}
    {Dis donc :NICK:, quel vent aujourd'hui !}
    {:NICK:> Ds que le vent soufflera, je repartira...}
    {:ACTION:essaie de montrer de l'intrt  :NICK: pour pas le laisser dans le vent...}
    {mais dis donc :NICK:, elle est super intressante ta question ! :)}
    {:ACTION:ajoute une petite croix sur son compteur de vents}
    {Ok :NICK:, question suivante ?}
    {\00304\002<<<  WARNING ! :NICK: : vent dtect  >>>\002\003}
    {D'autres questions ?}
    {*vent*}
    {Waw c'est vraiment super intressant ce que tu racontes :NICK: :)}
    {:NICK:> vive le vent, vive le vent, vive le vent d'hiver...}
    {C'est un vent de comptition a :)}
    {:ACTION:est compltement dcoiff par le vent que :NICK: s'est pris}
  }
  
  ##### Replies to use whenever someone gives a monolog.
  ##### You may add your own replies or translate these.
  ##### You may use some variables :
  #####     :ACTION: at the very beginning of a line will make the bot to talk
  #####              like a /me (ctcp action) 
  #####     :NICK: will be replaced by the nick of the user who triggered the
  #####            Blow off Detector.
  ##### Make sure you preserve the { } around the replies.
  #
  ##### Rponses du bot pour les vents dclenchs par un monologue.
  ##### Vous pouvez ajouter les vtres.
  ##### Il est possible d'utiliser des variables :
  #####     :ACTION: en dbut de ligne fera parler le bot en /me
  #####     :NICK: sera remplac par le nom de la personne qui a
  #####            dclench le dtecteur de vents.
  ##### Respectez bien les { } autour des rponses.
  set monolog_winds {
    {:ACTION:baille}
    {:ACTION:fait semblant d'couter}
    {Soit tu as mis tout le chan en ignore, soit tu parles tout seul :]}
    {Mais qu'est-ce qu'il raconte lui ? :s}
    {:ACTION:retourne :NICK: pour essayer de trouver comment on enlve les piles}
    {Bon, a n'intresse personne ce que :NICK: raconte ?}
    {Je crois que tout le monde a dcroch l.}
    {Tu parles tout seul :NICK: ?}
    {Ne regarde pas tout de suite mais je crois bien que tout le monde s'en fout}
    {Je crois bien que la personne  qui tu parlais s'est endormie ^^}
    {A qui tu parles :NICK: ?}
    {C'est donc a un vent :)}
    {Dis donc :NICK:, quel vent aujourd'hui !}
    {:NICK:> Ds que le vent soufflera, je repartira...}
    {:ACTION:essaie de montrer de l'intrt  :NICK: pour pas le laisser dans le vent...}
    {:ACTION:ajoute une petite croix sur son compteur de vents}
    {\00304\002<<<  WARNING ! :NICK: : vent dtect  >>>\002\003}
    {*vent*}
    {Waw c'est vraiment super intressant ce que tu racontes :NICK: :)}
    {:NICK:> vive le vent, vive le vent, vive le vent d'hiver...}
    {C'est un vent de comptition a :)}
  } 
  
####################################################################
#                                                                  #
#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
#                                                                  #
# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
#                                                                  #
####################################################################

  variable version "1.3"
  variable timeout ; array set timeout {}
  variable stored_nick ; array set stored_nick {}
  variable windtimer ; array set windtimer {}
  variable monolog_counter ; array set monolog_counter {}
  variable monolog_done ; array set monolog_done {}
  variable chanmems {} 
  foreach element [split $allowed_chans " "] {
    set stored_nick($element) ""
    set timeout($element) 0
    bind pubm - "$element *" wind_detector::main
  }
}


proc wind_detector::main {nick host hand chan text} {
  variable windtimer
  variable monolog_counter
  variable monolog_done
  variable timeout
  variable stored_nick
  variable chanmems
  set nick_allowed [lsearch -exact $wind_detector::exempt_list $nick]
  if { $stored_nick($chan) != $nick } {
    if { $nick_allowed != -1 } { return }
    catch { killutimer $windtimer($chan) }
    set c [lsearch $chanmems $chan ]
    if { $c != -1 } {
      lset chanmems [ lrange $chanmems 0 [expr $c - 1] ] [lrange $chanmems [expr $c + 1] end]
    }
    set stored_nick($chan) $nick
    set monolog_counter($chan) 1
    set timeout($chan) [clock seconds]
    set monolog_done($chan) 0
  } elseif {([clock seconds] != $timeout($chan)) && ([regexp {^!.*$} $text] == 0)} {
    set timeout($chan) [clock seconds]
    incr monolog_counter($chan)
  }
  if {([regexp {^[^!].*\?$} $text] == 1) && ([lsearch -exact $wind_detector::exempt_list $nick] == -1)} {
    set stored_nick($chan) $nick
    catch { killutimer $windtimer($chan) }
    lappend chanmems $chan
    set windtimer($chan) [utimer $wind_detector::trigger_delay {wind_detector::question_wind_detected }]
  }
  if { ($monolog_counter($chan) >= $wind_detector::monolog_trigger) && ($monolog_done($chan) != 1)} {
    wind_detector::monolog_wind_detected $chan $nick
  }
}

proc wind_detector::question_wind_detected {} {
  variable question_winds
  variable chanmems
  set chan [lindex $chanmems 0]
  set chanmems [ lrange $chanmems 1 end ]
  set random_wind [join [lindex $question_winds [rand [llength $question_winds]]] " "]
  wind_detector::wind_display $chan $random_wind
}

proc wind_detector::monolog_wind_detected {chan nick} {
  variable monolog_winds
  variable monolog_done
  set monolog_done($chan) 1
  catch { killutimer $wind_detector::windtimer($chan) }
  set random_wind [join [lindex $monolog_winds [rand [llength $monolog_winds]]] " "]
  wind_detector::wind_display $chan $random_wind
}

proc wind_detector::wind_display {chan random_wind} {
  variable stored_nick  
  variable monolog_counter
  set monolog_counter($chan) 0
  catch { killutimer $windtimer($chan) }
    if {[string match "*:ACTION:*" $random_wind] != 0} {
    set random_wind "\001ACTION $random_wind\001"
  } 
  set nickable $stored_nick($chan)
  set random_wind [string map {
    ":NICK:" ${nickable}
    ":ACTION:" ""
  } $random_wind] 
  set random_wind [subst $random_wind]
  putserv "PRIVMSG $chan :$random_wind"
  set reply "<$::botnick> $random_wind"
  putloglev p $chan $reply
}
  
putlog "\002*Dtecteur de vents/Blow off detector v$wind_detector::version*\002 by MenzAgitat (\037\00312http://www.boulets-roxx.com\003\037) has been loaded"
